open Skl;;
open Skl_extra;;

let is_gt = skl i -> ( < ) i;;
let con = skl x -> fun _ -> x;;
let minus = skl i -> fun x -> x - i;;
let mult = skl () -> fun (x, y) -> x * y;;
let add = skl () -> fun (x, y) -> x + y;;

let fact =
  dup () ||| (id () *** con 1) |||
  loop
    ( projl () ||| is_gt 1 
    , dup () |||
      ( (projl () ||| minus 1) ***
        mult ()
      )
    ) |||
  projr ()
;;

let fib =
  dup () ||| (id () *** con (1, 0)) |||
  loop
    ( projl () ||| is_gt 0
    , minus 1 ***
      (dup () ||| (add () *** projl ()))
    ) |||
  projr () ||| projr ()
;;

let main { Parfun.parfun = pf; } =
  let is =
    let il = [ 1; 2; 3; 4; 5; 6; 7; 8; ] in
    Sklstream.of_list il in
  let print_result f (x, fx) =
    Printf.printf "%s %d = %d\n%!" f x fx in
  Sklstream.iter (print_result "fact")
    (pf (dup () ||| (id () *** fact)) is);
  Sklstream.iter (print_result "fib")
    (pf (dup () ||| (id () *** fib)) is)
;;

Parfun.pardo main
;;
