(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2007-2012 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: options.mli,v 1.5 2012/09/27 15:25:17 fclement Exp $ *)

val add_options : unit -> unit;;
val parse_cmd_line : unit -> unit;;

val get_number_of_workers : unit -> int;;
val get_pool_size : unit -> int;;
val get_number_of_factors : unit -> int;;
val get_factor_size : unit -> int;;
val get_pool_directory : unit -> string;;
val get_temporary_directory : unit -> string;;
val get_cbits_directory : unit -> string;;
val get_prime_gen_path : unit -> string;;
val get_prime_check_path : unit -> string
val get_recover_data : unit -> (int list) option;;

type configuration = {
  number_of_workers : int;
  pool_size : int;
  number_of_factors : int;
  factor_size : int;
  pool_directory : string;
  temporary_directory : string;
  cbits_directory : string;
  recover_data : (int list) option
};;

val save_config : unit -> configuration;;
val set_config : configuration -> unit;;
