(***********************************************************************)
(*                                                                     *)
(*                                Sklml                                *)
(*                                                                     *)
(*                 The OCaml parallel skeleton system                  *)
(*                                                                     *)
(*               EPI Pomdapi, INRIA Paris - Rocquencourt               *)
(*                                                                     *)
(*  Copyright 2007-2014 INRIA.                                         *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Quentin Carbonneaux <Quentin.Carbonneaux@inria.fr>                 *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: parser.mli,v 1.9 2014/01/21 09:21:17 fclement Exp $ *)

type 'a parser;;

val parse : 'a parser -> string -> 'a option;;
val full_parse : 'a parser -> string -> ('a * string) option;;

val return : 'a -> 'a parser;;
val zero : 'a parser;;
val bind : 'a parser -> ('a -> 'b parser) -> 'b parser;;
val plus : 'a parser -> 'a parser -> 'a parser;;
val ( >>= ) : 'a parser -> ('a -> 'b parser) -> 'b parser;;
val ( >> ) : 'a parser -> 'b parser -> 'b parser;;
val ( +++ ) : 'a parser -> 'a parser -> 'a parser;;

val any : ('a parser) list -> 'a parser;;
val many : 'a parser -> ('a list) parser;;
val many1 : 'a parser -> ('a list) parser;;
val many_till : 'a parser -> 'b parser -> ('b list) parser;;
val times : int -> 'a parser -> 'a list parser;;
val less_than : int -> 'a parser -> 'a list parser;;
val maybe : 'a parser -> ('a option) parser;;

val char : char -> char parser;;
val eof : unit parser;;
